#ifdef __FB_LINUX__
'FM sound synthesis by Angelo Rosina, based on alsatest by d.j.peters
'Option Explicit

Const EAGAIN                       = -11 ' Try again
Const EPIPE                        = -32 ' Broken pipe
Const ESTRPIPE                     = -86 ' Streams pipe error

Const BLOCK                        = 0
Const NONBLOCK                     = 1
Const ASYNC                        = 2

Const SND_PCM_STREAM_PLAYBACK      = 0
Const SND_PCM_STREAM_CAPTURE       = 1
Const SND_PCM_FORMAT_S16_LE        = 2
Const SND_PCM_ACCESS_RW_INTERLEAVED= 3

#ifndef NULL
#define NULL 0
#endif

Type snd_pcm_t           As Any Ptr
Type snd_pcm_hw_params_t As Any Ptr
Type snd_output_t        As Any Ptr

' PCM
Declare Function snd_strerror Cdecl Alias "snd_strerror" ( _
Byval ecode As Integer) As Zstring Ptr

Declare Function snd_pcm_open Cdecl Alias "snd_pcm_open" ( _
Byval pcm          As snd_pcm_t Ptr, _
Byval device       As String, _
Byval direction    As Integer, _
Byval mode         As Integer) As Integer

Declare Function snd_pcm_close Cdecl Alias "snd_pcm_close" ( _
Byval pcm          As snd_pcm_t) As Integer

Declare Function snd_pcm_start Cdecl Alias "snd_pcm_start" ( _
Byval pcm          As snd_pcm_t) As Integer

Declare Function snd_pcm_drain Cdecl Alias "snd_pcm_drain" ( _
Byval pcm          As snd_pcm_t) As Integer

Declare Function snd_pcm_hw_free Cdecl Alias "snd_pcm_hw_free" ( _
Byval pcm          As snd_pcm_t) As Integer

Declare Function snd_pcm_nonblock Cdecl Alias "snd_pcm_nonblock" ( _
Byval pcm          As snd_pcm_t, _
Byval nonblock     As Integer) As Integer

Declare Function snd_pcm_prepare Cdecl Alias "snd_pcm_prepare" ( _
Byval pcm          As snd_pcm_t) As Integer

Declare Function snd_pcm_writei Cdecl Alias "snd_pcm_writei" ( _
Byval pcm          As snd_pcm_t, _
Byval buffer       As Any Ptr, _
Byval size         As Integer) As Integer

Declare Function snd_pcm_avail_update Cdecl Alias "snd_pcm_avail_update" ( _
Byval pcm          As snd_pcm_t) As Integer

Declare Function snd_pcm_wait Cdecl Alias "snd_pcm_wait" ( _
Byval pcm          As snd_pcm_t, _
Byval msec As Integer) As Integer

Declare Function snd_pcm_resume Cdecl Alias "snd_pcm_resume" ( _
Byval pcm          As snd_pcm_t) As Integer

'hardware
Declare Function snd_pcm_hw_params_malloc Cdecl Alias "snd_pcm_hw_params_malloc" ( _
Byval hw           As snd_pcm_hw_params_t Ptr) As Integer

Declare Function snd_pcm_hw_params_any Cdecl Alias "snd_pcm_hw_params_any" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t) As Integer

Declare Function snd_pcm_hw_params_set_access Cdecl Alias "snd_pcm_hw_params_set_access" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t, _
Byval mode         As Integer) As Integer

Declare Function snd_pcm_hw_params_set_format Cdecl Alias "snd_pcm_hw_params_set_format" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t, _
Byval fmt          As Integer) As Integer

Declare Function snd_pcm_hw_params_set_channels Cdecl Alias "snd_pcm_hw_params_set_channels" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t, _
Byval Channels     As Integer) As Integer

Declare Function snd_pcm_hw_params_get_channels Cdecl Alias "snd_pcm_hw_params_get_channels" ( _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpChannels   As Integer Ptr) As Integer

Declare Function snd_pcm_hw_params_set_rate_near Cdecl Alias "snd_pcm_hw_params_set_rate_near" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpRate       As Integer Ptr, _
Byval lpDir        As Integer Ptr) As Integer


Declare Function snd_pcm_hw_params_get_periods Cdecl Alias "snd_pcm_hw_params_get_periods" ( _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpValue      As Integer Ptr, _
Byval lpDir        As Integer Ptr) As Integer

Declare Function snd_pcm_hw_params_set_periods_near Cdecl Alias "snd_pcm_hw_params_set_periods_near" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpValue      As Integer Ptr, _
Byval lpDir        As Integer Ptr) As Integer

Declare Function snd_pcm_hw_params_get_period_size Cdecl Alias "snd_pcm_hw_params_get_period_size" ( _
Byval params       As snd_pcm_hw_params_t, _
Byval lpFrames     As Integer Ptr, _
Byval lpDir        As Integer Ptr) As Integer

'int  snd_pcm_hw_params_set_period_size_near (snd_pcm_t *pcm, snd_pcm_hw_params_t *params, snd_pcm_uframes_t *val, int *dir)
Declare Function snd_pcm_hw_params_set_period_size_near Cdecl Alias "snd_pcm_hw_params_set_period_size_near" ( _
Byval pcm          As snd_pcm_t Ptr, _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpValue      As Integer Ptr, _
Byval lpDir        As Integer Ptr) As Integer

Declare Function snd_pcm_hw_params_set_buffer_size_near Cdecl Alias "snd_pcm_hw_params_set_buffer_size_near" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpFrames     As Integer Ptr) As Integer

Declare Function snd_pcm_hw_params_get_buffer_size Cdecl Alias "snd_pcm_hw_params_get_buffer_size" ( _
Byval hw           As snd_pcm_hw_params_t, _
Byval lpFrames     As Integer Ptr) As Integer

Declare Function snd_pcm_hw_params Cdecl Alias "snd_pcm_hw_params" ( _
Byval pcm          As snd_pcm_t, _
Byval hw           As snd_pcm_hw_params_t) As Integer

Declare Sub snd_pcm_hw_params_free Cdecl Alias "snd_pcm_hw_params_free" ( _
Byval hw           As snd_pcm_hw_params_t)

#inclib "asound"



#define device "hw:0,0"


sub FMSound (Frequency as double, Duration as single, MaxVol as integer=128,_
	ca as single=0,cd as single=0,csl as single=1,cr as single=0,_
	MFrequency as double=0, ModStart as double=0, MaxModulator as Double=0,_
	ma as single=0,md as single=0,msl as single=1,mr as single=0) static

	Dim As snd_pcm_t Ptr           hDevice
	Dim As snd_pcm_hw_params_t Ptr hw
	Dim As Integer                 ret,value,direction,nbuffers,buffersize,nFrames,Periodsize
	Dim As Zstring Ptr             strRet

	ret = snd_pcm_open(@hDevice,device, SND_PCM_STREAM_PLAYBACK, NONBLOCK)
	ret=snd_pcm_nonblock(hDevice,NONBLOCK)
	snd_pcm_hw_params_malloc(@hw)
	ret = snd_pcm_hw_params_any(hDevice,hw)
	ret = snd_pcm_hw_params_set_access(hDevice, hw, SND_PCM_ACCESS_RW_INTERLEAVED)
	ret = snd_pcm_hw_params_set_format(hDevice,hw,2)
	ret = snd_pcm_hw_params_set_channels(hDevice,hw,2)
	value=44100 'set speed
	ret = snd_pcm_hw_params_set_rate_near(hDevice,hw,@value,@direction)
	nFrames=128 * 8 ' please try 8,7,6,5,4,3,2,1
	ret = snd_pcm_hw_params_set_period_size_near(hDevice, hw, @nFrames,0)
	Periodsize=nFrames\2
	ret = snd_pcm_hw_params_set_periods_near(hDevice, hw,@PeriodSize, 0)
	ret = snd_pcm_hw_params(hDevice,hw)
	snd_pcm_hw_params_free hw
	ret = snd_pcm_prepare(hDevice)
	BufferSize=nFrames*4
	nBuffers=PeriodSize
	ret=snd_pcm_avail_update(hDevice)

	Dim As Short Ptr ptr lpBuffers
	Dim As Integer i,j,p
	Dim As Single w1,f1=8*Atn(1)/44100*220
	Dim As Single w2,f2=8*Atn(1)/44100*330
	Dim As Single w3,f3=8*Atn(1)/44100*1

	dim as integer nSamples

	dim as single CS, MS

	nSamples=44100*int(Duration/18.2) ' seconds
	CS = 1 - CA - CD - CR
	MS = 1 - MA - MD - MR

	dim as double CEnvelopeInc, CEnvelopeDecD, CEnvelopeDecR
	CEnvelopeInc = 100 * MaxVol / (nSamples * CA + 1)
	CEnvelopeDecD = 100 * MaxVol * (1 - CSL) / (nSamples * CD + 1)
	CEnvelopeDecR = 100 * MaxVol * CSL / (nSamples * CR + 1)

	CD = CD + CA
	CS = CS + CD
	CR = CR + CS

	dim as double MEnvelopeInc, MEnvelopeDecD, MEnvelopeDecR
	MEnvelopeInc = MaxModulator / (nSamples * MA + 1)
	MEnvelopeDecD = MaxModulator * (1 - MSL) / (nSamples * MD + 1)
	MEnvelopeDecR = MaxModulator * MSL / (nSamples * MR + 1)

	MD = MD + MA
	MS = MS + MD
	MR = MR + MS



	lpBuffers=callocate(nBuffers * sizeof(Short Ptr))
	For i=0 To nBuffers-1
		lpBuffers[i]=allocate(Buffersize)
	Next

	dim Waveform As single
	dim Modulator as single
	dim Volume as double=0
	dim MAmp as double=0

	i=0
	While i<nSamples
		For j=0 To nBuffers-1
			For p=0 To (Buffersize Shr 1) - 2 Step 2
				IF i <= CA * nSamples THEN
					Volume = Volume + CEnvelopeInc
				ELSEIF i < CD * nSamples THEN
					Volume = Volume - CEnvelopeDecD
				ELSEIF i < CS * nSamples THEN
				ELSEIF i < CR * nSamples THEN
					Volume = Volume - CEnvelopeDecR
				END IF

				IF i <= MA * nSamples THEN
					Mamp = Mamp + MEnvelopeInc
				ELSEIF i < MD * nSamples THEN
					Mamp = Mamp - MEnvelopeDecD
				ELSEIF i < MS * nSamples THEN
				ELSEIF i < MR * nSamples THEN
					Mamp = Mamp - MEnvelopeDecR
				END IF

				Modulator=Cos(6.28/44100*i*MFrequency+ModStart)*MAmp
				Waveform=Sin(6.28/44100*i*Frequency+Modulator)*Volume

				lpBuffers[j][p  ]=Waveform
				lpBuffers[j][p+1]=Waveform
				i=i+1
			Next
			ret=EAGAIN
			While ret=EAGAIN
				ret=snd_pcm_writei(hDevice,lpBuffers[j],nFrames)
			Wend
			ret=snd_pcm_wait(hDevice,1000)

		Next
	Wend

	If hDevice<>NULL Then snd_pcm_close hDevice:hDevice=NULL
	If lpBuffers<>NULL Then
		For i=0 To nBuffers-1
			If lpBuffers[i] <> NULL Then deallocate lpBuffers[i]:lpBuffers[i]=NULL
		Next
		deallocate lpBuffers:lpBuffers=NULL
	End If
End sub
#endif
#ifdef __FB_WIN32__
'Programmed by Angelo Rosina

enum FLAGS
_ASYNC       = &h000001
_NODEFAULT   = &h000002
_MEMORY      = &h000004
_LOOP        = &h000008
_NOSTOP      = &h000010
_PURGE       = &h000040
_APPLICATION = &h000080
_NOWAIT      = &h002000
_ALIAS       = &h010000
_FILENAME    = &h020000
_RESOURCE    = &h040000 Or _MEMORY
_ALIAS_ID    = &h100000 Or _ALIAS
End enum

#define    PLAYFLAG _NOWAIT Or _NOSTOP Or _MEMORY Or _ASYNC
#define SNDPLAYFLAG            _NOSTOP Or _MEMORY Or _ASYNC
#define FCC(c) *(cptr(Uinteger Ptr,@##c))
Declare Function    PlayMemory Alias "PlaySoundA"    (Byval As Any Ptr,Byval hModule As Any Ptr=0,Byval flag As Integer=PLAYFLAG) As Integer
Declare Function sndPlayMemory Alias "sndPlaySoundA" (Byval As Any Ptr,Byval flag As Uinteger=SNDPLAYFLAG) As Integer
#inclib "winmm"

Sub PrepareBuffer(Byval lpBuffer  As Any Ptr, _
Byval nSamples  As Uinteger, _
Byval nRate     As Uinteger=44100, _
Byval nBits     As Uinteger=16, _
Byval nChannels As Uinteger=2)

Dim As Uinteger Ptr h=lpBuffer
Dim As Uinteger     BlkAlign=(nBits\8)*nChannels
Dim As Uinteger     DataSize=BlkAlign*nSamples
h[ 0]=FCC("RIFF")                ' RIFF chunk
h[ 1]=36 + DataSize              ' size of WAVE chunk + data size
h[ 2]=FCC("WAVE")                ' WAVE chunk
h[ 3]=FCC("fmt ")                ' fmt chunk
h[ 4]=16                         ' size of fmt chunk
h[ 5]=(nChannels Shl 16) Or 1    ' channels + PCM_FORMAT flag
h[ 6]=nRate                      ' playback rate
h[ 7]=BlkAlign*nRate             ' bytes per sec.
h[ 8]=(nBits Shl 16) Or BlkAlign ' bits per sample + blockalign
h[ 9]=FCC("data")                ' data chunk
h[10]=DataSize                   ' size of data chunk
End Sub


Type PCM_SAMPLE Field = 2
As Short l,r ' left and right channel
End Type

sub Sound (Frequency as double, Duration as single, MaxVol as integer=128,_
ca as single=0,cd as single=0,csl as single=1,cr as single=0,_
MFrequency as double=0, ModStart as double=0, MaxModulator as Double=0,_
ma as single=0,md as single=0,msl as single=1,mr as single=0)

Const nBuffers=2
var nSamples=44100*(Duration/18.2) ' seconds
var CS = 1 - CA - CD - CR
var MS = 1 - MA - MD - MR

dim as double CEnvelopeInc, CEnvelopeDecD, CEnvelopeDecR
CEnvelopeInc = 100 * MaxVol / (nSamples * CA + 1)
CEnvelopeDecD = 100 * MaxVol * (1 - CSL) / (nSamples * CD + 1)
CEnvelopeDecR = 100 * MaxVol * CSL / (nSamples * CR + 1)

CD = CD + CA
CS = CS + CD
CR = CR + CS

dim as double MEnvelopeInc, MEnvelopeDecD, MEnvelopeDecR
MEnvelopeInc = MaxModulator / (nSamples * MA + 1)
MEnvelopeDecD = MaxModulator * (1 - MSL) / (nSamples * MD + 1)
MEnvelopeDecR = MaxModulator * MSL / (nSamples * MR + 1)

MD = MD + MA
MS = MS + MD
MR = MR + MS



Dim As PCM_SAMPLE PlayBuffers(nBuffers-1,-22 To nSamples-1)
For i As Integer=0 To nBuffers-1
PrepareBuffer(@PlayBuffers(i,-22),nSamples)
Next

dim Waveform As single
dim Modulator as single
Dim As Integer buffer,ret
dim Volume as double=0
dim MAmp as double=0


' fill the first buffer with sine wave
For i As Integer=0 To nSamples-1

IF i <= CA * nSamples THEN
Volume = Volume + CEnvelopeInc
ELSEIF i < CD * nSamples THEN
Volume = Volume - CEnvelopeDecD
ELSEIF i < CS * nSamples THEN
ELSEIF i < CR * nSamples THEN
Volume = Volume - CEnvelopeDecR
END IF

IF i <= MA * nSamples THEN
Mamp = Mamp + MEnvelopeInc
ELSEIF i < MD * nSamples THEN
Mamp = Mamp - MEnvelopeDecD
ELSEIF i < MS * nSamples THEN
ELSEIF i < MR * nSamples THEN
Mamp = Mamp - MEnvelopeDecR
END IF

Modulator=Cos(6.28/44100*i*MFrequency+ModStart)*MAmp
Waveform=Sin(6.28/44100*i*Frequency+Modulator)*Volume
PlayBuffers(buffer,i).l=Waveform
PlayBuffers(buffer,i).r=Waveform
Next

ret=PlayMemory(@PlayBuffers(buffer,-22))
end sub
#endif
'fmsound 500,10*18.2,256,0,.1,.01,.5,500,.5,30,0,.1,.5,.6 ' guitar
'fmsound 3000,10*18.2,256,0.5,.2,1,.1,10,.5,1000,.6,.2,.7,2    ' An UFO?
'fmsound 500,10*18.2,256,0.5,.2,1,.1,10,.5,200,.6,.2,.7,2   'Helicopter
'fmsound 50,10*18.2,256,0,0,1,.1,20,.5,410  ' an Engine